OpenCV: Basic structures

| OpenCV 3.4.2 Open Source Computer Vision

Namespaces | Classes | Typedefs | Enumerations | Functions | Variables
Basic structures
Core functionality

## Namespaces
| cv::traits

## Classes
class | cv::_InputArray
| This is the proxy class for passing read-only input arrays into OpenCV functions. More...
class | cv::_InputOutputArray
class | cv::_OutputArray
| This type is very similar to InputArray except that it is used for input/output and output function parameters. More...
class | cv::Algorithm
| This is a base class for all more or less complex algorithms in OpenCV. More...
class | cv::Complex< _Tp >
| A complex number class. More...
class | cv::DataDepth< _Tp >
| A helper class for cv::DataType. More...
class | cv::DataType< _Tp >
| Template "trait" class for OpenCV primitive data types. More...
class | cv::DMatch
| Class for matching keypoint descriptors. More...
class | cv::Formatted
class | cv::Formatter
class | cv::KeyPoint
| Data structure for salient point detectors. More...
class | cv::Mat
| n-dimensional dense array class More...
class | cv::Mat_< _Tp >
| Template matrix class derived from Mat. More...
class | cv::MatAllocator
| Custom array allocator. More...
class | cv::MatCommaInitializer_< _Tp >
| Comma-separated Matrix Initializer. More...
class | cv::MatConstIterator
class | cv::MatConstIterator_< _Tp >
| Matrix read-only iterator. More...
class | cv::MatExpr
| Matrix expression representation. More...
class | cv::MatIterator_< _Tp >
| Matrix read-write iterator. More...
class | cv::MatOp
struct | cv::MatSize
struct | cv::MatStep
class | cv::Matx< _Tp, m, n >
| Template class for small matrices whose type and size are known at compilation time. More...
class | cv::MatxCommaInitializer< _Tp, m, n >
| Comma-separated Matrix Initializer. More...
class | cv::NAryMatIterator
| n-ary multi-dimensional array iterator. More...
struct | cv::Param
struct | cv::ParamType< _Tp >
struct | cv::ParamType< Algorithm >
struct | cv::ParamType< bool >
struct | cv::ParamType< double >
struct | cv::ParamType< float >
struct | cv::ParamType< Mat >
struct | cv::ParamType< Scalar >
struct | cv::ParamType< std::vector< Mat > >
struct | cv::ParamType< String >
struct | cv::ParamType< uchar >
struct | cv::ParamType< uint64 >
struct | cv::ParamType< unsigned >
class | cv::Point3_< _Tp >
| Template class for 3D points specified by its coordinates `x`, `y` and `z`. More...
class | cv::Point_< _Tp >
| Template class for 2D points specified by its coordinates `x` and `y`. More...
struct | cv::Ptr< T >
| Template class for smart pointers with shared ownership. More...
class | cv::Range
| Template class specifying a continuous subsequence (slice) of a sequence. More...
class | cv::Rect_< _Tp >
| Template class for 2D rectangles. More...
class | cv::RotatedRect
| The class represents rotated (i.e. not up-right) rectangles on a plane. More...
class | cv::Scalar_< _Tp >
| Template class for a 4-element vector derived from Vec. More...
class | cv::Size_< _Tp >
| Template class for specifying the size of an image or rectangle. More...
class | cv::SparseMat
| The class SparseMat represents multi-dimensional sparse numerical arrays. More...
class | cv::SparseMat_< _Tp >
| Template sparse n-dimensional array class derived from SparseMat. More...
class | cv::SparseMatConstIterator
| Read-Only Sparse Matrix Iterator. More...
class | cv::SparseMatConstIterator_< _Tp >
| Template Read-Only Sparse Matrix Iterator Class. More...
class | cv::SparseMatIterator
| Read-write Sparse Matrix Iterator. More...
class | cv::SparseMatIterator_< _Tp >
| Template Read-Write Sparse Matrix Iterator Class. More...
class | cv::String
class | cv::TermCriteria
| The class defining termination criteria for iterative algorithms. More...
class | cv::UMat
struct | cv::UMatData
class | cv::Vec< _Tp, cn >
| Template class for short numerical vectors, a partial case of Matx. More...
class | cv::VecCommaInitializer< _Tp, m >
| Comma-separated Vec Initializer. More...

## Typedefs
typedef Complex< double > | cv::Complexd
typedef Complex< float > | cv::Complexf
typedef InputArray | cv::InputArrayOfArrays
typedef const _InputOutputArray & | cv::InputOutputArray
typedef InputOutputArray | cv::InputOutputArrayOfArrays
typedef Mat_< uchar > | cv::Mat1b
typedef Mat_< double > | cv::Mat1d
typedef Mat_< float > | cv::Mat1f
typedef Mat_< int > | cv::Mat1i
typedef Mat_< short > | cv::Mat1s
typedef Mat_< ushort > | cv::Mat1w
typedef Mat_< Vec2b > | cv::Mat2b
typedef Mat_< Vec2d > | cv::Mat2d
typedef Mat_< Vec2f > | cv::Mat2f
typedef Mat_< Vec2i > | cv::Mat2i
typedef Mat_< Vec2s > | cv::Mat2s
typedef Mat_< Vec2w > | cv::Mat2w
typedef Mat_< Vec3b > | cv::Mat3b
typedef Mat_< Vec3d > | cv::Mat3d
typedef Mat_< Vec3f > | cv::Mat3f
typedef Mat_< Vec3i > | cv::Mat3i
typedef Mat_< Vec3s > | cv::Mat3s
typedef Mat_< Vec3w > | cv::Mat3w
typedef Mat_< Vec4b > | cv::Mat4b
typedef Mat_< Vec4d > | cv::Mat4d
typedef Mat_< Vec4f > | cv::Mat4f
typedef Mat_< Vec4i > | cv::Mat4i
typedef Mat_< Vec4s > | cv::Mat4s
typedef Mat_< Vec4w > | cv::Mat4w
typedef Matx< double, 1, 2 > | cv::Matx12d
typedef Matx< float, 1, 2 > | cv::Matx12f
typedef Matx< double, 1, 3 > | cv::Matx13d
typedef Matx< float, 1, 3 > | cv::Matx13f
typedef Matx< double, 1, 4 > | cv::Matx14d
typedef Matx< float, 1, 4 > | cv::Matx14f
typedef Matx< double, 1, 6 > | cv::Matx16d
typedef Matx< float, 1, 6 > | cv::Matx16f
typedef Matx< double, 2, 1 > | cv::Matx21d
typedef Matx< float, 2, 1 > | cv::Matx21f
typedef Matx< double, 2, 2 > | cv::Matx22d
typedef Matx< float, 2, 2 > | cv::Matx22f
typedef Matx< double, 2, 3 > | cv::Matx23d
typedef Matx< float, 2, 3 > | cv::Matx23f
typedef Matx< double, 3, 1 > | cv::Matx31d
typedef Matx< float, 3, 1 > | cv::Matx31f
typedef Matx< double, 3, 2 > | cv::Matx32d
typedef Matx< float, 3, 2 > | cv::Matx32f
typedef Matx< double, 3, 3 > | cv::Matx33d
typedef Matx< float, 3, 3 > | cv::Matx33f
typedef Matx< double, 3, 4 > | cv::Matx34d
typedef Matx< float, 3, 4 > | cv::Matx34f
typedef Matx< double, 4, 1 > | cv::Matx41d
typedef Matx< float, 4, 1 > | cv::Matx41f
typedef Matx< double, 4, 3 > | cv::Matx43d
typedef Matx< float, 4, 3 > | cv::Matx43f
typedef Matx< double, 4, 4 > | cv::Matx44d
typedef Matx< float, 4, 4 > | cv::Matx44f
typedef Matx< double, 6, 1 > | cv::Matx61d
typedef Matx< float, 6, 1 > | cv::Matx61f
typedef Matx< double, 6, 6 > | cv::Matx66d
typedef Matx< float, 6, 6 > | cv::Matx66f
typedef const _OutputArray & | cv::OutputArray
typedef OutputArray | cv::OutputArrayOfArrays
typedef Point2i | cv::Point
typedef Point_< double > | cv::Point2d
typedef Point_< float > | cv::Point2f
typedef Point_< int > | cv::Point2i
typedef Point_< int64 > | cv::Point2l
typedef Point3_< double > | cv::Point3d
typedef Point3_< float > | cv::Point3f
typedef Point3_< int > | cv::Point3i
typedef Rect2i | cv::Rect
typedef Rect_< double > | cv::Rect2d
typedef Rect_< float > | cv::Rect2f
typedef Rect_< int > | cv::Rect2i
typedef Scalar_< double > | cv::Scalar
typedef Size2i | cv::Size
typedef Size_< double > | cv::Size2d
typedef Size_< float > | cv::Size2f
typedef Size_< int > | cv::Size2i
typedef Size_< int64 > | cv::Size2l

## Enumerations
enum | { cv::ACCESS_READ =1<<24, cv::ACCESS_WRITE =1<<25, cv::ACCESS_RW =3<<24, cv::ACCESS_MASK =ACCESS_RW, cv::ACCESS_FAST =1<<26 }
enum | cv::UMatUsageFlags { cv::USAGE_DEFAULT = 0, cv::USAGE_ALLOCATE_HOST_MEMORY = 1 << 0, cv::USAGE_ALLOCATE_DEVICE_MEMORY = 1 << 1, cv::USAGE_ALLOCATE_SHARED_MEMORY = 1 << 2, cv::__UMAT_USAGE_FLAGS_32BIT = 0x7fffffff }
| Usage flags for allocator. More...

## Functions
template<typename _Tp , int m>
static double | cv::determinant (const Matx< _Tp, m, m > &a)
template<typename T >
Ptr< T > | cv::makePtr ()
template<typename T , typename A1 >
Ptr< T > | cv::makePtr (const A1 &a1)
template<typename T , typename A1 , typename A2 >
Ptr< T > | cv::makePtr (const A1 &a1, const A2 &a2)
template<typename T , typename A1 , typename A2 , typename A3 >
Ptr< T > | cv::makePtr (const A1 &a1, const A2 &a2, const A3 &a3)
template<typename T , typename A1 , typename A2 , typename A3 , typename A4 >
Ptr< T > | cv::makePtr (const A1 &a1, const A2 &a2, const A3 &a3, const A4 &a4)
template<typename T , typename A1 , typename A2 , typename A3 , typename A4 , typename A5 >
Ptr< T > | cv::makePtr (const A1 &a1, const A2 &a2, const A3 &a3, const A4 &a4, const A5 &a5)
template<typename T , typename A1 , typename A2 , typename A3 , typename A4 , typename A5 , typename A6 >
Ptr< T > | cv::makePtr (const A1 &a1, const A2 &a2, const A3 &a3, const A4 &a4, const A5 &a5, const A6 &a6)
template<typename T , typename A1 , typename A2 , typename A3 , typename A4 , typename A5 , typename A6 , typename A7 >
Ptr< T > | cv::makePtr (const A1 &a1, const A2 &a2, const A3 &a3, const A4 &a4, const A5 &a5, const A6 &a6, const A7 &a7)
template<typename T , typename A1 , typename A2 , typename A3 , typename A4 , typename A5 , typename A6 , typename A7 , typename A8 >
Ptr< T > | cv::makePtr (const A1 &a1, const A2 &a2, const A3 &a3, const A4 &a4, const A5 &a5, const A6 &a6, const A7 &a7, const A8 &a8)
template<typename T , typename A1 , typename A2 , typename A3 , typename A4 , typename A5 , typename A6 , typename A7 , typename A8 , typename A9 >
Ptr< T > | cv::makePtr (const A1 &a1, const A2 &a2, const A3 &a3, const A4 &a4, const A5 &a5, const A6 &a6, const A7 &a7, const A8 &a8, const A9 &a9)
template<typename T , typename A1 , typename A2 , typename A3 , typename A4 , typename A5 , typename A6 , typename A7 , typename A8 , typename A9 , typename A10 >
Ptr< T > | cv::makePtr (const A1 &a1, const A2 &a2, const A3 &a3, const A4 &a4, const A5 &a5, const A6 &a6, const A7 &a7, const A8 &a8, const A9 &a9, const A10 &a10)
InputOutputArray | cv::noArray ()
template<typename _Tp , int m, int n>
static double | cv::norm (const Matx< _Tp, m, n > &M)
template<typename _Tp , int m, int n>
static double | cv::norm (const Matx< _Tp, m, n > &M, int normType)
template<typename _Tp , int cn>
static Vec< _Tp, cn > | cv::normalize (const Vec< _Tp, cn > &v)
template<typename T >
bool | cv::operator!= (const Ptr< T > &ptr1, const Ptr< T > &ptr2)
static String & | cv::operator<< (String &out, Ptr< Formatted > fmtd)
static String & | cv::operator<< (String &out, const Mat &mtx)
template<typename T >
bool | cv::operator== (const Ptr< T > &ptr1, const Ptr< T > &ptr2)
template<typename T >
void | cv::swap (Ptr< T > &ptr1, Ptr< T > &ptr2)
template<typename _Tp , int m, int n>
static double | cv::trace (const Matx< _Tp, m, n > &a)

## Variables
CV__DEBUG_NS_END typedef const _InputArray & | cv::InputArray

## Shorter aliases for the most popular specializations of Vec<T,n>
typedef Vec< uchar, 2 > | cv::Vec2b
typedef Vec< uchar, 3 > | cv::Vec3b
typedef Vec< uchar, 4 > | cv::Vec4b
typedef Vec< short, 2 > | cv::Vec2s
typedef Vec< short, 3 > | cv::Vec3s
typedef Vec< short, 4 > | cv::Vec4s
typedef Vec< ushort, 2 > | cv::Vec2w
typedef Vec< ushort, 3 > | cv::Vec3w
typedef Vec< ushort, 4 > | cv::Vec4w
typedef Vec< int, 2 > | cv::Vec2i
typedef Vec< int, 3 > | cv::Vec3i
typedef Vec< int, 4 > | cv::Vec4i
typedef Vec< int, 6 > | cv::Vec6i
typedef Vec< int, 8 > | cv::Vec8i
typedef Vec< float, 2 > | cv::Vec2f
typedef Vec< float, 3 > | cv::Vec3f
typedef Vec< float, 4 > | cv::Vec4f
typedef Vec< float, 6 > | cv::Vec6f
typedef Vec< double, 2 > | cv::Vec2d
typedef Vec< double, 3 > | cv::Vec3d
typedef Vec< double, 4 > | cv::Vec4d
typedef Vec< double, 6 > | cv::Vec6d

## Detailed Description

## Typedef Documentation

## ◆ Complexd

typedef Complex<double> cv::Complexd

## ◆ Complexf

typedef Complex<float> cv::Complexf

## ◆ InputArrayOfArrays

typedef InputArray cv::InputArrayOfArrays

## ◆ InputOutputArray

typedef const _InputOutputArray& cv::InputOutputArray

## ◆ InputOutputArrayOfArrays

typedef InputOutputArray cv::InputOutputArrayOfArrays

## ◆ Mat1b

typedef Mat_<uchar> cv::Mat1b

## ◆ Mat1d

typedef Mat_<double> cv::Mat1d

## ◆ Mat1f

typedef Mat_<float> cv::Mat1f

## ◆ Mat1i

typedef Mat_<int> cv::Mat1i

## ◆ Mat1s

typedef Mat_<short> cv::Mat1s

## ◆ Mat1w

typedef Mat_<ushort> cv::Mat1w

## ◆ Mat2b

typedef Mat_<Vec2b> cv::Mat2b

## ◆ Mat2d

typedef Mat_<Vec2d> cv::Mat2d

## ◆ Mat2f

typedef Mat_<Vec2f> cv::Mat2f

## ◆ Mat2i

typedef Mat_<Vec2i> cv::Mat2i

## ◆ Mat2s

typedef Mat_<Vec2s> cv::Mat2s

## ◆ Mat2w

typedef Mat_<Vec2w> cv::Mat2w

## ◆ Mat3b

typedef Mat_<Vec3b> cv::Mat3b

## ◆ Mat3d

typedef Mat_<Vec3d> cv::Mat3d

## ◆ Mat3f

typedef Mat_<Vec3f> cv::Mat3f

## ◆ Mat3i

typedef Mat_<Vec3i> cv::Mat3i

## ◆ Mat3s

typedef Mat_<Vec3s> cv::Mat3s

## ◆ Mat3w

typedef Mat_<Vec3w> cv::Mat3w

## ◆ Mat4b

typedef Mat_<Vec4b> cv::Mat4b

## ◆ Mat4d

typedef Mat_<Vec4d> cv::Mat4d

## ◆ Mat4f

typedef Mat_<Vec4f> cv::Mat4f

## ◆ Mat4i

typedef Mat_<Vec4i> cv::Mat4i

## ◆ Mat4s

typedef Mat_<Vec4s> cv::Mat4s

## ◆ Mat4w

typedef Mat_<Vec4w> cv::Mat4w

## ◆ Matx12d

typedef Matx<double, 1, 2> cv::Matx12d

## ◆ Matx12f

typedef Matx<float, 1, 2> cv::Matx12f

## ◆ Matx13d

typedef Matx<double, 1, 3> cv::Matx13d

## ◆ Matx13f

typedef Matx<float, 1, 3> cv::Matx13f

## ◆ Matx14d

typedef Matx<double, 1, 4> cv::Matx14d

## ◆ Matx14f

typedef Matx<float, 1, 4> cv::Matx14f

## ◆ Matx16d

typedef Matx<double, 1, 6> cv::Matx16d

## ◆ Matx16f

typedef Matx<float, 1, 6> cv::Matx16f

## ◆ Matx21d

typedef Matx<double, 2, 1> cv::Matx21d

## ◆ Matx21f

typedef Matx<float, 2, 1> cv::Matx21f

## ◆ Matx22d

typedef Matx<double, 2, 2> cv::Matx22d

## ◆ Matx22f

typedef Matx<float, 2, 2> cv::Matx22f

## ◆ Matx23d

typedef Matx<double, 2, 3> cv::Matx23d

## ◆ Matx23f

typedef Matx<float, 2, 3> cv::Matx23f

## ◆ Matx31d

typedef Matx<double, 3, 1> cv::Matx31d

## ◆ Matx31f

typedef Matx<float, 3, 1> cv::Matx31f

## ◆ Matx32d

typedef Matx<double, 3, 2> cv::Matx32d

## ◆ Matx32f

typedef Matx<float, 3, 2> cv::Matx32f

## ◆ Matx33d

typedef Matx<double, 3, 3> cv::Matx33d

## ◆ Matx33f

typedef Matx<float, 3, 3> cv::Matx33f

## ◆ Matx34d

typedef Matx<double, 3, 4> cv::Matx34d

## ◆ Matx34f

typedef Matx<float, 3, 4> cv::Matx34f

## ◆ Matx41d

typedef Matx<double, 4, 1> cv::Matx41d

## ◆ Matx41f

typedef Matx<float, 4, 1> cv::Matx41f

## ◆ Matx43d

typedef Matx<double, 4, 3> cv::Matx43d

## ◆ Matx43f

typedef Matx<float, 4, 3> cv::Matx43f

## ◆ Matx44d

typedef Matx<double, 4, 4> cv::Matx44d

## ◆ Matx44f

typedef Matx<float, 4, 4> cv::Matx44f

## ◆ Matx61d

typedef Matx<double, 6, 1> cv::Matx61d

## ◆ Matx61f

typedef Matx<float, 6, 1> cv::Matx61f

## ◆ Matx66d

typedef Matx<double, 6, 6> cv::Matx66d

## ◆ Matx66f

typedef Matx<float, 6, 6> cv::Matx66f

## ◆ OutputArray

typedef const _OutputArray& cv::OutputArray

## ◆ OutputArrayOfArrays

typedef OutputArray cv::OutputArrayOfArrays

## ◆ Point

typedef Point2i cv::Point

Examples:
  camshiftdemo.cpp, contours2.cpp, demhist.cpp, Drawing_1.cpp, facedetect.cpp, falsecolor.cpp, ffilldemo.cpp, fitellipse.cpp, grabcut.cpp, hog.cpp, houghcircles.cpp, houghlines.cpp, MatchTemplate_Demo.cpp, morphology2.cpp, Morphology_1.cpp, peopledetect.cpp, polar_transforms.cpp, segment_objects.cpp, Smoothing.cpp, and watershed.cpp.

## ◆ Point2d

typedef Point_<double> cv::Point2d

## ◆ Point2f

typedef Point_<float> cv::Point2f

Examples:
  cout_mat.cpp, fitellipse.cpp, kalman.cpp, lkdemo.cpp, pose_from_homography.cpp, and warpPerspective_demo.cpp.

## ◆ Point2i

typedef Point_<int> cv::Point2i

## ◆ Point2l

typedef Point_<int64> cv::Point2l

## ◆ Point3d

typedef Point3_<double> cv::Point3d

## ◆ Point3f

typedef Point3_<float> cv::Point3f

## ◆ Point3i

typedef Point3_<int> cv::Point3i

## ◆ Rect

typedef Rect2i cv::Rect

Examples:
  camshiftdemo.cpp, facedetect.cpp, falsecolor.cpp, grabcut.cpp, and train_HOG.cpp.

## ◆ Rect2d

typedef Rect_<double> cv::Rect2d

## ◆ Rect2f

typedef Rect_<float> cv::Rect2f

## ◆ Rect2i

typedef Rect_<int> cv::Rect2i

## ◆ Scalar

typedef Scalar_<double> cv::Scalar

Examples:
  camshiftdemo.cpp, contours2.cpp, convexhull.cpp, decompose_homography.cpp, distrans.cpp, Drawing_1.cpp, Drawing_2.cpp, facedetect.cpp, falsecolor.cpp, ffilldemo.cpp, fitellipse.cpp, grabcut.cpp, hog.cpp, homography_from_camera_displacement.cpp, houghcircles.cpp, houghlines.cpp, image_alignment.cpp, kalman.cpp, kmeans.cpp, lkdemo.cpp, lsd_lines.cpp, minarea.cpp, peopledetect.cpp, polar_transforms.cpp, train_HOG.cpp, and warpPerspective_demo.cpp.

## ◆ Size

typedef Size2i cv::Size

Examples:
  contours2.cpp, Drawing_1.cpp, edge.cpp, facedetect.cpp, falsecolor.cpp, hog.cpp, image_alignment.cpp, laplace.cpp, lkdemo.cpp, morphology2.cpp, Morphology_1.cpp, peopledetect.cpp, polar_transforms.cpp, Pyramids.cpp, Smoothing.cpp, Sobel_Demo.cpp, train_HOG.cpp, and warpPerspective_demo.cpp.

## ◆ Size2d

typedef Size_<double> cv::Size2d

## ◆ Size2f

typedef Size_<float> cv::Size2f

## ◆ Size2i

typedef Size_<int> cv::Size2i

## ◆ Size2l

typedef Size_<int64> cv::Size2l

## ◆ Vec2b

typedef Vec<uchar, 2> cv::Vec2b

## ◆ Vec2d

typedef Vec<double, 2> cv::Vec2d

## ◆ Vec2f

typedef Vec<float, 2> cv::Vec2f

## ◆ Vec2i

typedef Vec<int, 2> cv::Vec2i

## ◆ Vec2s

typedef Vec<short, 2> cv::Vec2s

## ◆ Vec2w

typedef Vec<ushort, 2> cv::Vec2w

## ◆ Vec3b

typedef Vec<uchar, 3> cv::Vec3b

Examples:
  camshiftdemo.cpp, and watershed.cpp.

## ◆ Vec3d

typedef Vec<double, 3> cv::Vec3d

## ◆ Vec3f

typedef Vec<float, 3> cv::Vec3f

## ◆ Vec3i

typedef Vec<int, 3> cv::Vec3i

## ◆ Vec3s

typedef Vec<short, 3> cv::Vec3s

## ◆ Vec3w

typedef Vec<ushort, 3> cv::Vec3w

## ◆ Vec4b

typedef Vec<uchar, 4> cv::Vec4b

## ◆ Vec4d

typedef Vec<double, 4> cv::Vec4d

## ◆ Vec4f

typedef Vec<float, 4> cv::Vec4f

## ◆ Vec4i

typedef Vec<int, 4> cv::Vec4i

## ◆ Vec4s

typedef Vec<short, 4> cv::Vec4s

## ◆ Vec4w

typedef Vec<ushort, 4> cv::Vec4w

## ◆ Vec6d

typedef Vec<double, 6> cv::Vec6d

## ◆ Vec6f

typedef Vec<float, 6> cv::Vec6f

## ◆ Vec6i

typedef Vec<int, 6> cv::Vec6i

## ◆ Vec8i

typedef Vec<int, 8> cv::Vec8i

## Enumeration Type Documentation

## ◆ anonymous enum

anonymous enum

Enumerator
ACCESS_READ |
ACCESS_WRITE |
ACCESS_RW |
ACCESS_MASK |
ACCESS_FAST |

## ◆ UMatUsageFlags

enum cv::UMatUsageFlags

Usage flags for allocator.

Enumerator
USAGE_DEFAULT |
USAGE_ALLOCATE_HOST_MEMORY |
USAGE_ALLOCATE_DEVICE_MEMORY |
USAGE_ALLOCATE_SHARED_MEMORY |
__UMAT_USAGE_FLAGS_32BIT |

## Function Documentation

## ◆ determinant()

template<typename _Tp , int m>

static double cv::determinant | ( | const Matx< _Tp, m, m > & | a | ) |
| static

Examples:
  pose_from_homography.cpp.

## ◆ makePtr() [1/11]

template<typename T >

Ptr<T> cv::makePtr | ( |  | ) |

`makePtr<T>(...)` is equivalent to `Ptr<T>(new T(...))`. It is shorter than the latter, and it's marginally safer than using a constructor or Ptr::reset, since it ensures that the owned pointer is new and thus not owned by any other Ptr instance. Unfortunately, perfect forwarding is impossible to implement in C++03, and so makePtr is limited to constructors of T that have up to 10 arguments, none of which are non-const references.

## ◆ makePtr() [2/11]

template<typename T , typename A1 >

Ptr<T> cv::makePtr | ( | const A1 & | a1 | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ makePtr() [3/11]

template<typename T , typename A1 , typename A2 >

Ptr<T> cv::makePtr | ( | const A1 & | a1,
|  | const A2 & | a2
| ) |  |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ makePtr() [4/11]

template<typename T , typename A1 , typename A2 , typename A3 >

Ptr<T> cv::makePtr | ( | const A1 & | a1,
|  | const A2 & | a2,
|  | const A3 & | a3
| ) |  |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ makePtr() [5/11]

template<typename T , typename A1 , typename A2 , typename A3 , typename A4 >

Ptr<T> cv::makePtr | ( | const A1 & | a1,
|  | const A2 & | a2,
|  | const A3 & | a3,
|  | const A4 & | a4
| ) |  |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ makePtr() [6/11]

template<typename T , typename A1 , typename A2 , typename A3 , typename A4 , typename A5 >

Ptr<T> cv::makePtr | ( | const A1 & | a1,
|  | const A2 & | a2,
|  | const A3 & | a3,
|  | const A4 & | a4,
|  | const A5 & | a5
| ) |  |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ makePtr() [7/11]

template<typename T , typename A1 , typename A2 , typename A3 , typename A4 , typename A5 , typename A6 >

Ptr<T> cv::makePtr | ( | const A1 & | a1,
|  | const A2 & | a2,
|  | const A3 & | a3,
|  | const A4 & | a4,
|  | const A5 & | a5,
|  | const A6 & | a6
| ) |  |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ makePtr() [8/11]

template<typename T , typename A1 , typename A2 , typename A3 , typename A4 , typename A5 , typename A6 , typename A7 >

Ptr<T> cv::makePtr | ( | const A1 & | a1,
|  | const A2 & | a2,
|  | const A3 & | a3,
|  | const A4 & | a4,
|  | const A5 & | a5,
|  | const A6 & | a6,
|  | const A7 & | a7
| ) |  |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ makePtr() [9/11]

template<typename T , typename A1 , typename A2 , typename A3 , typename A4 , typename A5 , typename A6 , typename A7 , typename A8 >

Ptr<T> cv::makePtr | ( | const A1 & | a1,
|  | const A2 & | a2,
|  | const A3 & | a3,
|  | const A4 & | a4,
|  | const A5 & | a5,
|  | const A6 & | a6,
|  | const A7 & | a7,
|  | const A8 & | a8
| ) |  |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ makePtr() [10/11]

template<typename T , typename A1 , typename A2 , typename A3 , typename A4 , typename A5 , typename A6 , typename A7 , typename A8 , typename A9 >

Ptr<T> cv::makePtr | ( | const A1 & | a1,
|  | const A2 & | a2,
|  | const A3 & | a3,
|  | const A4 & | a4,
|  | const A5 & | a5,
|  | const A6 & | a6,
|  | const A7 & | a7,
|  | const A8 & | a8,
|  | const A9 & | a9
| ) |  |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ makePtr() [11/11]

template<typename T , typename A1 , typename A2 , typename A3 , typename A4 , typename A5 , typename A6 , typename A7 , typename A8 , typename A9 , typename A10 >

Ptr<T> cv::makePtr | ( | const A1 & | a1,
|  | const A2 & | a2,
|  | const A3 & | a3,
|  | const A4 & | a4,
|  | const A5 & | a5,
|  | const A6 & | a6,
|  | const A7 & | a7,
|  | const A8 & | a8,
|  | const A9 & | a9,
|  | const A10 & | a10
| ) |  |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ noArray()

InputOutputArray cv::noArray | ( |  | ) |

## ◆ norm() [1/2]

template<typename _Tp , int m, int n>

static double cv::norm | ( | const Matx< _Tp, m, n > & | M | ) |
| static

Examples:
  lkdemo.cpp, pose_from_homography.cpp, and warpPerspective_demo.cpp.

## ◆ norm() [2/2]

template<typename _Tp , int m, int n>

static double cv::norm | ( | const Matx< _Tp, m, n > & | M,
|  | int | normType
| ) |  |
| static

## ◆ normalize()

template<typename _Tp , int cn>

static Vec<_Tp, cn> cv::normalize | ( | const Vec< _Tp, cn > & | v | ) |
| static

Examples:
  camshiftdemo.cpp, demhist.cpp, MatchTemplate_Demo.cpp, and pca.cpp.

## ◆ operator!=()

template<typename T >

bool cv::operator!= | ( | const Ptr< T > & | ptr1,
|  | const Ptr< T > & | ptr2
| ) |  |

## ◆ operator<<() [1/2]

static String& cv::operator<< | ( | String & | out,
|  | Ptr< Formatted > | fmtd
| ) |  |
| inlinestatic

## ◆ operator<<() [2/2]

static String& cv::operator<< | ( | String & | out,
|  | const Mat & | mtx
| ) |  |
| inlinestatic

## ◆ operator==()

template<typename T >

bool cv::operator== | ( | const Ptr< T > & | ptr1,
|  | const Ptr< T > & | ptr2
| ) |  |

Return whether ptr1.get() and ptr2.get() are equal and not equal, respectively.

## ◆ swap()

template<typename T >

void cv::swap | ( | Ptr< T > & | ptr1,
|  | Ptr< T > & | ptr2
| ) |  |

Equivalent to ptr1.swap(ptr2). Provided to help write generic algorithms.

Examples:
  lkdemo.cpp, and warpPerspective_demo.cpp.

## ◆ trace()

template<typename _Tp , int m, int n>

static double cv::trace | ( | const Matx< _Tp, m, n > & | a | ) |
| static

## Variable Documentation

## ◆ InputArray

CV__DEBUG_NS_END typedef const _InputArray& cv::InputArray

Examples:
  pca.cpp, and peopledetect.cpp.